﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using com.jnbridge.embedding;
using java.awt.@event;
using com.jnbridge.jnbcore;

namespace J_in_WPF
{
    [AsyncCallback("java.awt.event.ActionListener")]
    public class DotNetActionListener : ActionListener
    {
        private java.awt.TextField javaTextBox;
        private TextBox wpfTextBox;

        public DotNetActionListener(java.awt.TextField jTB, TextBox dNTB)
        {
            javaTextBox = jTB;
            wpfTextBox = dNTB;
        }

        private delegate void setTextBox(string s);
        private void setTextBoxProc(string s)
        {
            wpfTextBox.Text = s;
        }

        #region ActionListener Members

        public void actionPerformed(ActionEvent p1)
        {
            string s = javaTextBox.getText();
            // IMPORTANT!  The change to wpfTextBox (or any WPF control) must be done in the control's owning thread
            // or an exception will be thrown!
            wpfTextBox.Dispatcher.Invoke(new setTextBox(setTextBoxProc), new object[] { s });
        }

        #endregion

    }

    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
            try
            {
                jInN.JavaComponent jcp = new jInN.JavaComponent();
                jcp.addActionListener(new DotNetActionListener(jcp.javaTextBox, wpfTextBox));

                this.mainGrid.Children.Add(new JavaWPFControl(jcp, 400, 100));
            }
            catch (Exception e)
            {
            }
        }
    }
}
